Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.http.nio.protocol
Class AsyncNHttpClientHandler

    java.lang.Object
      org.apache.http.nio.protocol.NHttpHandlerBase
          org.apache.http.nio.protocol.AsyncNHttpClientHandler

All Implemented Interfaces:
  NHttpClientHandler

Deprecated. (4.2) use `HttpAsyncRequestExecutor` and `HttpAsyncRequester`

    @Deprecated
    @Contract(threading=IMMUTABLE_CONDITIONAL)
    public class AsyncNHttpClientHandler

extends NHttpHandlerBase
implements NHttpClientHandler

Fully asynchronous HTTP client side protocol handler that implements the essential requirements of the HTTP protocol for the server side message processing as described by RFC 2616. It is capable of executing HTTP requests with nearly constant memory footprint. Only HTTP message heads are stored in memory, while content of message bodies is streamed directly from the entity to the underlying channel (and vice versa) using `ConsumingNHttpEntity` and `ProducingNHttpEntity` interfaces. When using this implementation, it is important to ensure that entities supplied for writing implement `ProducingNHttpEntity`. Doing so will allow the entity to be written out asynchronously. If entities supplied for writing do not implement the `ProducingNHttpEntity` interface, a delegate is added that buffers the entire contents in memory. Additionally, the buffering might take place in the I/O dispatch thread, which could cause I/O to block temporarily. For best results, one must ensure that all entities set on `HttpRequest`s from `NHttpRequestExecutionHandler` implement `ProducingNHttpEntity`. If incoming responses enclose a content entity, `NHttpRequestExecutionHandler` are expected to return a `ConsumingNHttpEntity` for reading the content. After the entity is finished reading the data, `NHttpRequestExecutionHandler.handleResponse(HttpResponse, HttpContext)` method is called to process the response.

The following parameters can be used to customize the behavior of this class:

- `CoreProtocolPNames.WAIT_FOR_CONTINUE`

Since:
  4.0

Nested Class Summary
`protected static class` | `AsyncNHttpClientHandler.ClientConnState` Deprecated.

Field Summary
`protected NHttpRequestExecutionHandler` | `execHandler` Deprecated.

Fields inherited from class org.apache.http.nio.protocol.NHttpHandlerBase
`allocator, CONN_STATE, connStrategy, eventListener, httpProcessor, params`

Constructor Summary
`AsyncNHttpClientHandler(HttpProcessor httpProcessor, NHttpRequestExecutionHandler execHandler, ConnectionReuseStrategy connStrategy, ByteBufferAllocator allocator, HttpParams params)` Deprecated.
`AsyncNHttpClientHandler(HttpProcessor httpProcessor, NHttpRequestExecutionHandler execHandler, ConnectionReuseStrategy connStrategy, HttpParams params)` Deprecated.

Method Summary
`void` | `closed(NHttpClientConnection conn)` Deprecated. Triggered when the connection is closed.
`void` | `connected(NHttpClientConnection conn, Object attachment)` Deprecated. Triggered when a new outgoing connection is created.
`void` | `exception(NHttpClientConnection conn, HttpException ex)` Deprecated. Triggered when an HTTP protocol violation occurs while receiving an HTTP response.
`void` | `exception(NHttpClientConnection conn, IOException ex)` Deprecated. Triggered when an I/O error occurs while reading from or writing to the underlying channel.
`void` | `inputReady(NHttpClientConnection conn, ContentDecoder decoder)` Deprecated. Triggered when the underlying channel is ready for reading a new portion of the response entity through the corresponding content decoder.
`void` | `outputReady(NHttpClientConnection conn, ContentEncoder encoder)` Deprecated. Triggered when the underlying channel is ready for writing a next portion of the request entity through the corresponding content encoder.
`void` | `requestReady(NHttpClientConnection conn)` Deprecated. Triggered when the connection is ready to accept a new HTTP request.
`void` | `responseReceived(NHttpClientConnection conn)` Deprecated. Triggered when an HTTP response is received.
`void` | `timeout(NHttpClientConnection conn)` Deprecated. Triggered when no input is detected on this connection over the maximum period of inactivity.

Methods inherited from class org.apache.http.nio.protocol.NHttpHandlerBase
`canResponseHaveBody, closeConnection, getParams, handleTimeout, setEventListener, shutdownConnection`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### execHandler

    protected NHttpRequestExecutionHandler execHandler

  Deprecated.

Constructor Detail

### AsyncNHttpClientHandler

    public AsyncNHttpClientHandler(HttpProcessor httpProcessor,
                                   NHttpRequestExecutionHandler execHandler,
                                   ConnectionReuseStrategy connStrategy,
                                   ByteBufferAllocator allocator,
                                   HttpParams params)

  Deprecated.

### AsyncNHttpClientHandler

    public AsyncNHttpClientHandler(HttpProcessor httpProcessor,
                                   NHttpRequestExecutionHandler execHandler,
                                   ConnectionReuseStrategy connStrategy,
                                   HttpParams params)

  Deprecated.

Method Detail

### connected

    public void connected(NHttpClientConnection conn,
                          Object attachment)

  Deprecated.
  Description copied from interface: `NHttpClientHandler`
  Triggered when a new outgoing connection is created.

  Specified by:
    `connected` in interface `NHttpClientHandler`
  Parameters:
    `conn` - new outgoing HTTP connection.
    `attachment` - an object that was attached to the session request

### closed

    public void closed(NHttpClientConnection conn)

  Deprecated.
  Description copied from interface: `NHttpClientHandler`
  Triggered when the connection is closed.

  Specified by:
    `closed` in interface `NHttpClientHandler`
  Parameters:
    `conn` - closed HTTP connection.

### exception

    public void exception(NHttpClientConnection conn,
                          HttpException ex)

  Deprecated.
  Description copied from interface: `NHttpClientHandler`
  Triggered when an HTTP protocol violation occurs while receiving an HTTP response.

  Specified by:
    `exception` in interface `NHttpClientHandler`
  Parameters:
    `conn` - HTTP connection that caused an HTTP protocol violation
    `ex` - HTTP protocol violation exception

### exception

    public void exception(NHttpClientConnection conn,
                          IOException ex)

  Deprecated.
  Description copied from interface: `NHttpClientHandler`
  Triggered when an I/O error occurs while reading from or writing to the underlying channel.

  Specified by:
    `exception` in interface `NHttpClientHandler`
  Parameters:
    `conn` - HTTP connection that caused an I/O error
    `ex` - I/O exception

### requestReady

    public void requestReady(NHttpClientConnection conn)

  Deprecated.
  Description copied from interface: `NHttpClientHandler`
  Triggered when the connection is ready to accept a new HTTP request. The protocol handler does not have to submit a request if it is not ready.

  Specified by:
    `requestReady` in interface `NHttpClientHandler`
  Parameters:
    `conn` - HTTP connection that is ready to accept a new HTTP request.
  See Also:
    `NHttpClientConnection`

### inputReady

    public void inputReady(NHttpClientConnection conn,
                           ContentDecoder decoder)

  Deprecated.
  Description copied from interface: `NHttpClientHandler`
  Triggered when the underlying channel is ready for reading a new portion of the response entity through the corresponding content decoder.

  If the content consumer is unable to process the incoming content, input event notifications can be temporarily suspended using `IOControl` interface.

  Specified by:
    `inputReady` in interface `NHttpClientHandler`
  Parameters:
    `conn` - HTTP connection that can produce a new portion of the incoming response content.
    `decoder` - The content decoder to use to read content.
  See Also:
    `NHttpClientConnection`, `ContentDecoder`, `IOControl`

### outputReady

    public void outputReady(NHttpClientConnection conn,
                            ContentEncoder encoder)

  Deprecated.
  Description copied from interface: `NHttpClientHandler`
  Triggered when the underlying channel is ready for writing a next portion of the request entity through the corresponding content encoder.

  If the content producer is unable to generate the outgoing content, output event notifications can be temporarily suspended using `IOControl` interface.

  Specified by:
    `outputReady` in interface `NHttpClientHandler`
  Parameters:
    `conn` - HTTP connection that can accommodate a new portion of the outgoing request content.
    `encoder` - The content encoder to use to write content.
  See Also:
    `NHttpClientConnection`, `ContentEncoder`, `IOControl`

### responseReceived

    public void responseReceived(NHttpClientConnection conn)

  Deprecated.
  Description copied from interface: `NHttpClientHandler`
  Triggered when an HTTP response is received. The connection passed as a parameter to this method is guaranteed to return a valid HTTP response object.

  If the response received encloses a response entity this method will be followed by a series of `NHttpClientHandler.inputReady(NHttpClientConnection, ContentDecoder)` calls to transfer the response content.

  Specified by:
    `responseReceived` in interface `NHttpClientHandler`
  Parameters:
    `conn` - HTTP connection that contains an HTTP response
  See Also:
    `NHttpClientConnection`

### timeout

    public void timeout(NHttpClientConnection conn)

  Deprecated.
  Description copied from interface: `NHttpClientHandler`
  Triggered when no input is detected on this connection over the maximum period of inactivity.

  Specified by:
    `timeout` in interface `NHttpClientHandler`
  Parameters:
    `conn` - HTTP connection that caused timeout condition.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.